
int cellsx=10; // number of cells in rows
int cellsy=8; // number of rows

int num; // total number of squares including the moving one


int w=100; // cell size
int w2=w/2; // half the cell size
int w4=w/4; // a q uarter of the cell size for checking colors
int w54=5*w4; // 5/4 of a cell size for color checking

color white= color(255); // white background
color black= color(230, 230, 230); // black grid

IntList list; //list of all the fields on the screen except the first one. cellsx * cellsy minus the first square
int[] choice= new int[cellsx*cellsy]; // shuffled list in an array where first num-1=19 will be chosen

 Kiss[] kisser; // object array
 color[] c; // color array
 int[] x; // x coordinate array
 int[] y; // y coorinate array
 
 boolean[] overbox;
 boolean[] locked;
 
 int [] xoffset;
 int [] yoffset;
 
 
 // random shit
 int seed;
 
 // images
 PImage buttons;
 PImage name;
 PImage grid;
 
 //controls
 PFont font;
 
 int prenum;
 int gridswitch;
 
 // check cursor for color
 color curc;



//===========================




void setup(){
  
 size(1000, 850);
 
 prenum=20;
 num=20; // initial number of squares
 
kisser = new Kiss[num]; // object array
c= new color[num]; // color array
x= new int[num]; // x coordinate array
y= new int[num]; // y coorinate array

overbox = new boolean[num];
locked = new boolean[num];
 
xoffset = new int[num];
yoffset = new int[num];

 
 seed=int(random(1000000));
 randomSeed(seed);
 

 // making a list of 100 integers, shuffling them and filling a separate array
 list = new IntList(); 
 for(int i=0; i<cellsx*cellsy; i++){
  list.append(i); 
 } 
 list.shuffle();
 choice = list.array();
 
 
 
 
 // filling the arrays
  
 for(int i=0; i<x.length; i++){
 x[i] = (choice[i] % cellsx)*w;
 y[i] = ((choice[i] - (choice[i] % cellsx)) / cellsx)*w;

 c[i] = color(random(1, 255), random(1, 255), random(1, 255)); 
 // avoid grid color
 if(c[i]==black){
  float redd=red(c[i]); 
  float greenn=green(c[i]); 
  float bluee=blue(c[i]); 
  c[i]=color(redd, greenn, bluee);
   
 }
 
 kisser[i]=new Kiss(i); 
 overbox[i]=false;
 locked[i]=false;
   
 }
 
 
 
 //images and controls
 buttons=loadImage("buttons.png");
 name=loadImage("name.png");
 grid=loadImage("grid.png");
 
 font = loadFont("GothamRounded-Book-12.vlw");
 textFont(font);
  textSize(12);

 noSmooth();
 
 gridswitch=2;

}




//===========================




void draw(){
  background(255);
  
  
  
   //// ======= grid
  
  noFill();
  if (gridswitch%2==0){
  stroke(black);
  }
  else
  {
   stroke(0, 0); 
  
  }
  for(int l=w; l<width; l=l+w){    
   line(l, 0, l, height);   
  }
    for(int m=w; m<width; m=m+w){    
   line(0, m, width, m);   
  }
  
  
  
  

// drawing the cells  
  for(int i=0; i<kisser.length; i++){
      kisser[i].base();
      
    }
  for(int i=0; i<kisser.length; i++){
      kisser[i].display(); 
    }
  
 
  
  
  
  // Test if the cursor is over the box 
  for(int i=0; i<x.length; i++){
  if (mouseX > x[i] && mouseX < x[i]+w && 
      mouseY > y[i] && mouseY < y[i]+w) {
    overbox[i] = true; 
  } 
  else 
  {
    overbox[i] = false;
  }
  }
  
  
  
  
  
  
 

  
  
  
  
  
  
  
  
  // footer and controls

  noStroke();
  fill(0);
  rect(0, cellsy*w, width, 50);
  
  
  image(buttons, 0, cellsy*w);
  image(name, width-(name.width), cellsy*w);
  
  // num
  fill(150);
  textAlign(CENTER);
  text(str(prenum), 55, height-20);
  
 
  // grid icon change
  
  if(gridswitch%2!=0){
    image(grid, 181, (cellsy*w)+16);
  }
    else{
      
    }
    
    
    
    // cursors
    
    
    //playing field
       curc=get(mouseX, mouseY);
    
    
    if(mouseY<=cellsy*w){
      if((curc==black || curc==white)){
      cursor(ARROW);
      
      }
      else{
        cursor(HAND);
      }
    }
      
     // footer cursors 
     
     if(mouseY>=cellsy*w){
     
     if(
        ((mouseX>16 && mouseX<16+19) && (mouseY>(cellsy*w)+16 && mouseY<(cellsy*w)+16+19))  ||   
        ((mouseX>74 && mouseX<74+19) && (mouseY>(cellsy*w)+16 && mouseY<(cellsy*w)+16+19))  ||
        ((mouseX>181 && mouseX<181+19) && (mouseY>(cellsy*w)+16 && mouseY<(cellsy*w)+16+19)) ||
        ((mouseX>100 && mouseX<100+19) && (mouseY>(cellsy*w)+16 && mouseY<(cellsy*w)+16+19))
        )
        {
      
cursor(HAND);
        }
        else{
          
        cursor(ARROW);  
          
        }
     }
    
    
    
    
    

  
}




//===========================



void mousePressed(){
if((mouseX>0 && mouseX<width) && (mouseY>0 && mouseY<height-50)){ // game play area
 for(int i=0; i<x.length; i++){ 
  
  if(overbox[i] == true) { 
    locked[i] = true; 
    
  } 
  else 
  {
    locked[i] = false;
  }
   
   
   
  xoffset[i]= (floor(mouseX/w)*w)-x[i]; 
  yoffset[i]= (floor(mouseY/w)*w)-y[i]; 
   

  
 }
}

// controls area

// minus
if((mouseX>16 && mouseX<16+19) && (mouseY>(cellsy*w)+16 && mouseY<(cellsy*w)+16+19)){
  prenum=prenum-1;
  if(prenum<0){
   prenum=0; 
  }

}

//plus
if((mouseX>74 && mouseX<74+19) && (mouseY>(cellsy*w)+16 && mouseY<(cellsy*w)+16+19)){
  prenum=prenum+1;
  if(prenum>cellsx*cellsy){
   prenum=cellsx*cellsy; 
  }

}

// grid on off
if((mouseX>181 && mouseX<181+19) && (mouseY>(cellsy*w)+16 && mouseY<(cellsy*w)+16+19)){
  gridswitch=gridswitch+1;

}


// randomize based on the chosen number of fields

if((mouseX>100 && mouseX<100+19) && (mouseY>(cellsy*w)+16 && mouseY<(cellsy*w)+16+19)){

seed=int(random(1000000));
  randomSeed(seed);
  
  num=prenum; // initial number of squares
 
kisser = new Kiss[num]; // object array
c= new color[num]; // color array
x= new int[num]; // x coordinate array
y= new int[num]; // y coorinate array

overbox = new boolean[num];
locked = new boolean[num];
 
xoffset = new int[num];
yoffset = new int[num];
  
  
  

 // making a list of 100 integers, shuffling them and filling a separate array
 list = new IntList(); 
 for(int i=0; i<cellsx*cellsy; i++){
  list.append(i); 
 } 
 list.shuffle();
 choice = list.array();
 

 // filling the arrays
  
 for(int i=0; i<x.length; i++){
 x[i] = (choice[i] % cellsx)*w;
 y[i] = ((choice[i] - (choice[i] % cellsx)) / cellsx)*w;
   
 c[i] = color(random(1, 255), random(1, 255), random(1, 255)); 
 kisser[i]=new Kiss(i); 
   
 }

}

}  
  
  


//===========================





void mouseDragged(){
  if((mouseX>0 && mouseX<width) && (mouseY>0 && mouseY<height-50)){
   for(int i=0; i<x.length; i++){ 
     if(locked[i]==true) {
      x[i] = (floor(mouseX/w)*w)-xoffset[i]; 
      y[i] = (floor(mouseY/w)*w)-yoffset[i]; 
  }
   }

  }   
}




//===========================




void mouseReleased() {
  if((mouseX>0 && mouseX<width) && (mouseY>0 && mouseY<height-50)){
  for(int i=0; i<x.length; i++){ 
  locked[i] = false;
  }
  }
}





//===========================





void keyPressed(){
if(key=='r' || key=='R'){
  
  
  
}


if(key=='s' || key=='S'){
 String p=str(seed) + "_" + str(num) + ".png";
 saveFrame(p);
  
}

}






//===========================
// define Kiss class based on the index of the element only




class Kiss{
  int i;


// constructor
Kiss(int _i){
  i=_i;

}

//put some base color first just for others to recognize that there is something there

void base(){
  noStroke();
  fill(254);
  rect(x[i], y[i], w, w);
  



} // end of base function

void display(){ // all the shit it does

noStroke();

// up segment

color  uc=get(int(x[i]+w2), int(y[i]-w4));
  if((uc==white || uc==black) || uc==0){
    fill(c[i]);
  }
  else{
   // cycle through y values and see what is kissing me from above and find its index

   for(int j=0; j<num; j++){
    if(y[j] == y[i]-w && x[j]==x[i]){
    color kissu = lerpColor(c[j], c[i], 0.5);
   fill(kissu); 
    }
   }
  }

triangle(x[i], y[i], x[i]+w, y[i], x[i]+w2, y[i]+w2);


// right segment 
 
 color rc=get(int(x[i]+w54), int(y[i]+w2));
  if((rc==white || rc==black) || rc==0){
    fill(c[i]);
    
  }
  else{
   // cycle through y values and see what is kissing me from the right and find its index

   for(int j=0; j<num; j++){
    if(x[j] == x[i]+w && y[j]==y[i]){
    color kissr = lerpColor(c[j], c[i], 0.5);
   fill(kissr);
    }
   }
   
  }
  
  triangle(x[i]+w, y[i], x[i]+w, y[i]+w, x[i]+w2, y[i]+w2);


// bottom segment 
  
  color dc=get(int(x[i]+w2), int(y[i]+w54));
  if((dc==white || dc==black) || dc==0){
    fill(c[i]);
  }
  else{
   // cycle through y values and see what is kissing me from below and find its index
 
   for(int j=0; j<num; j++){
    if(y[j] == y[i]+w && x[j]==x[i]){
    color kissd = lerpColor(c[j], c[i], 0.5);
    fill(kissd);
    }
   }
   
  }
  
  triangle(x[i], y[i]+w, x[i]+w, y[i]+w, x[i]+w2, y[i]+w2);
  
  
  //left segment
  
  color lc=get(int(x[i]-w4), int(y[i]+w2));
  if((lc==white || lc==black) || lc==0){
    fill(c[i]);
  }
  else{
   // cycle through y values and see what is kissing me from the left and find its index

   for(int j=0; j<num; j++){
    if(x[j] == x[i]-w && y[j]==y[i]){
  
    color kissl = lerpColor(c[j], c[i], 0.5);
    fill(kissl);
    }
   }
   
  }
  
  triangle(x[i], y[i], x[i], y[i]+w, x[i]+w2, y[i]+w2);



} // end of display function
} // end of the class